/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GuidGroupValueTuple type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GuidGroupValueTuple{}

// GuidGroupValueTuple struct for GuidGroupValueTuple
type GuidGroupValueTuple struct {
	Item1 *string `json:"item1,omitempty"`
	Item2 *Group  `json:"item2,omitempty"`
}

// NewGuidGroupValueTuple instantiates a new GuidGroupValueTuple object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGuidGroupValueTuple() *GuidGroupValueTuple {
	this := GuidGroupValueTuple{}
	return &this
}

// NewGuidGroupValueTupleWithDefaults instantiates a new GuidGroupValueTuple object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGuidGroupValueTupleWithDefaults() *GuidGroupValueTuple {
	this := GuidGroupValueTuple{}
	return &this
}

// GetItem1 returns the Item1 field value if set, zero value otherwise.
func (o *GuidGroupValueTuple) GetItem1() string {
	if o == nil || IsNil(o.Item1) {
		var ret string
		return ret
	}
	return *o.Item1
}

// GetItem1Ok returns a tuple with the Item1 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GuidGroupValueTuple) GetItem1Ok() (*string, bool) {
	if o == nil || IsNil(o.Item1) {
		return nil, false
	}
	return o.Item1, true
}

// HasItem1 returns a boolean if a field has been set.
func (o *GuidGroupValueTuple) HasItem1() bool {
	if o != nil && !IsNil(o.Item1) {
		return true
	}

	return false
}

// SetItem1 gets a reference to the given string and assigns it to the Item1 field.
func (o *GuidGroupValueTuple) SetItem1(v string) {
	o.Item1 = &v
}

// GetItem2 returns the Item2 field value if set, zero value otherwise.
func (o *GuidGroupValueTuple) GetItem2() Group {
	if o == nil || IsNil(o.Item2) {
		var ret Group
		return ret
	}
	return *o.Item2
}

// GetItem2Ok returns a tuple with the Item2 field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GuidGroupValueTuple) GetItem2Ok() (*Group, bool) {
	if o == nil || IsNil(o.Item2) {
		return nil, false
	}
	return o.Item2, true
}

// HasItem2 returns a boolean if a field has been set.
func (o *GuidGroupValueTuple) HasItem2() bool {
	if o != nil && !IsNil(o.Item2) {
		return true
	}

	return false
}

// SetItem2 gets a reference to the given Group and assigns it to the Item2 field.
func (o *GuidGroupValueTuple) SetItem2(v Group) {
	o.Item2 = &v
}

func (o GuidGroupValueTuple) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GuidGroupValueTuple) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Item1) {
		toSerialize["item1"] = o.Item1
	}
	if !IsNil(o.Item2) {
		toSerialize["item2"] = o.Item2
	}
	return toSerialize, nil
}

type NullableGuidGroupValueTuple struct {
	value *GuidGroupValueTuple
	isSet bool
}

func (v NullableGuidGroupValueTuple) Get() *GuidGroupValueTuple {
	return v.value
}

func (v *NullableGuidGroupValueTuple) Set(val *GuidGroupValueTuple) {
	v.value = val
	v.isSet = true
}

func (v NullableGuidGroupValueTuple) IsSet() bool {
	return v.isSet
}

func (v *NullableGuidGroupValueTuple) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGuidGroupValueTuple(val *GuidGroupValueTuple) *NullableGuidGroupValueTuple {
	return &NullableGuidGroupValueTuple{value: val, isSet: true}
}

func (v NullableGuidGroupValueTuple) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGuidGroupValueTuple) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
